<template>
  <div class="row justify-content-center">
    <div class="col-8">
      <form name="editForm" role="form" novalidate v-on:submit.prevent="save()">
        <h2
          id="coopcycleApp.utilisateur.home.createOrEditLabel"
          data-cy="UtilisateurCreateUpdateHeading"
          v-text="$t('coopcycleApp.utilisateur.home.createOrEditLabel')"
        >
          Create or edit a Utilisateur
        </h2>
        <div>
          <div class="form-group" v-if="utilisateur.id">
            <label for="id" v-text="$t('global.field.id')">ID</label>
            <input type="text" class="form-control" id="id" name="id" v-model="utilisateur.id" readonly />
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.utilisateur.nomUtilisateur')" for="utilisateur-nomUtilisateur"
              >Nom Utilisateur</label
            >
            <input
              type="text"
              class="form-control"
              name="nomUtilisateur"
              id="utilisateur-nomUtilisateur"
              data-cy="nomUtilisateur"
              :class="{ valid: !$v.utilisateur.nomUtilisateur.$invalid, invalid: $v.utilisateur.nomUtilisateur.$invalid }"
              v-model="$v.utilisateur.nomUtilisateur.$model"
              required
            />
            <div v-if="$v.utilisateur.nomUtilisateur.$anyDirty && $v.utilisateur.nomUtilisateur.$invalid">
              <small class="form-text text-danger" v-if="!$v.utilisateur.nomUtilisateur.required" v-text="$t('entity.validation.required')">
                This field is required.
              </small>
              <small
                class="form-text text-danger"
                v-if="!$v.utilisateur.nomUtilisateur.minLength"
                v-text="$t('entity.validation.minlength', { min: 2 })"
              >
                This field is required to be at least 2 characters.
              </small>
              <small
                class="form-text text-danger"
                v-if="!$v.utilisateur.nomUtilisateur.pattern"
                v-text="$t('entity.validation.pattern', { pattern: 'Nom Utilisateur' })"
              >
                This field should follow pattern for "Nom Utilisateur".
              </small>
            </div>
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.utilisateur.age')" for="utilisateur-age">Age</label>
            <input
              type="number"
              class="form-control"
              name="age"
              id="utilisateur-age"
              data-cy="age"
              :class="{ valid: !$v.utilisateur.age.$invalid, invalid: $v.utilisateur.age.$invalid }"
              v-model.number="$v.utilisateur.age.$model"
              required
            />
            <div v-if="$v.utilisateur.age.$anyDirty && $v.utilisateur.age.$invalid">
              <small class="form-text text-danger" v-if="!$v.utilisateur.age.required" v-text="$t('entity.validation.required')">
                This field is required.
              </small>
              <small class="form-text text-danger" v-if="!$v.utilisateur.age.min" v-text="$t('entity.validation.min', { min: 18 })">
                This field should be at least 18.
              </small>
              <small class="form-text text-danger" v-if="!$v.utilisateur.age.numeric" v-text="$t('entity.validation.number')">
                This field should be a number.
              </small>
            </div>
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.utilisateur.addresse')" for="utilisateur-addresse">Addresse</label>
            <input
              type="text"
              class="form-control"
              name="addresse"
              id="utilisateur-addresse"
              data-cy="addresse"
              :class="{ valid: !$v.utilisateur.addresse.$invalid, invalid: $v.utilisateur.addresse.$invalid }"
              v-model="$v.utilisateur.addresse.$model"
              required
            />
            <div v-if="$v.utilisateur.addresse.$anyDirty && $v.utilisateur.addresse.$invalid">
              <small class="form-text text-danger" v-if="!$v.utilisateur.addresse.required" v-text="$t('entity.validation.required')">
                This field is required.
              </small>
            </div>
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.utilisateur.role')" for="utilisateur-role">Role</label>
            <select
              class="form-control"
              name="role"
              :class="{ valid: !$v.utilisateur.role.$invalid, invalid: $v.utilisateur.role.$invalid }"
              v-model="$v.utilisateur.role.$model"
              id="utilisateur-role"
              data-cy="role"
              required
            >
              <option v-for="role in roleValues" :key="role" v-bind:value="role" v-bind:label="$t('coopcycleApp.Role.' + role)">
                {{ role }}
              </option>
            </select>
            <div v-if="$v.utilisateur.role.$anyDirty && $v.utilisateur.role.$invalid">
              <small class="form-text text-danger" v-if="!$v.utilisateur.role.required" v-text="$t('entity.validation.required')">
                This field is required.
              </small>
            </div>
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.utilisateur.course')" for="utilisateur-course">Course</label>
            <select class="form-control" id="utilisateur-course" data-cy="course" name="course" v-model="utilisateur.course">
              <option v-bind:value="null"></option>
              <option
                v-bind:value="utilisateur.course && courseOption.id === utilisateur.course.id ? utilisateur.course : courseOption"
                v-for="courseOption in courses"
                :key="courseOption.id"
              >
                {{ courseOption.id }}
              </option>
            </select>
          </div>
        </div>
        <div>
          <button type="button" id="cancel-save" data-cy="entityCreateCancelButton" class="btn btn-secondary" v-on:click="previousState()">
            <font-awesome-icon icon="ban"></font-awesome-icon>&nbsp;<span v-text="$t('entity.action.cancel')">Cancel</span>
          </button>
          <button
            type="submit"
            id="save-entity"
            data-cy="entityCreateSaveButton"
            :disabled="$v.utilisateur.$invalid || isSaving"
            class="btn btn-primary"
          >
            <font-awesome-icon icon="save"></font-awesome-icon>&nbsp;<span v-text="$t('entity.action.save')">Save</span>
          </button>
        </div>
      </form>
    </div>
  </div>
</template>
<script lang="ts" src="./utilisateur-update.component.ts"></script>
